use std::path::PathBuf;

use bft_json_crdt::json_crdt::SignedOp;
use serde_json::{json, Value};

pub(crate) const KEY_FILE: &str = "keys.pem";
pub(crate) const CONFIG_FILE: &str = "config.toml";

/// Returns the path to the key file and config for this host OS.
pub(crate) fn side_paths(prefix: PathBuf) -> (PathBuf, PathBuf) {
    let mut key_path = prefix.clone();
    key_path.push(KEY_FILE);

    let mut config_path = prefix.clone();
    config_path.push(CONFIG_FILE);

    (key_path, config_path)
}

pub(crate) fn home(name: &String) -> std::path::PathBuf {
    let mut path = dirs::home_dir().unwrap();
    path.push(".side");
    path.push(name);
    path
}

/// Generate a fake transaction with customizable from_pubkey String
pub fn fake_transaction_json(from: String) -> Value {
    json!({
        "from": from,
        "to": "Bob",
        "amount": 1
    })
}

pub fn shappy(op: SignedOp) -> String {
    let b = serde_json::to_string(&op).unwrap().into_bytes();
    sha256::digest(b).to_string()
}

pub fn shassy(text: String) -> String {
    let b = text.into_bytes();
    sha256::digest(b).to_string()
}
